=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2009-02-21 00:18:15 +0000
+++ drizzled/set_var.cc	2009-02-25 20:28:23 +0000
@@ -2320,8 +2320,18 @@
   transform(lower_var.begin(), lower_var.end(), lower_var.begin(), ::tolower);
   map<string, sys_var *>::iterator result_iter=
     system_variable_hash.find(lower_var);
-  if (result_iter == system_variable_hash.end() && (!no_error))
-    my_error(ER_UNKNOWN_SYSTEM_VARIABLE, MYF(0), (char*) str);
+  if (result_iter == system_variable_hash.end())
+  {
+    if (no_error)
+    {
+      return NULL;
+    }
+    else
+    {
+      my_error(ER_UNKNOWN_SYSTEM_VARIABLE, MYF(0), (char*) str);
+      return NULL;
+    }
+  }
 
   return (*result_iter).second;
 }

=== modified file 'mysys/default.cc'
--- mysys/default.cc	2009-02-21 00:18:15 +0000
+++ mysys/default.cc	2009-02-25 21:54:09 +0000
@@ -393,6 +393,7 @@
 				 (*argc + 1)*sizeof(char*))))
       goto err;
     res= (char**) (ptr+sizeof(alloc));
+    memset(res,0,(*argc + 1));
     res[0]= **argv;				/* Copy program name */
     for (i=2 ; i < (uint32_t) *argc ; i++)
       res[i-1]=argv[0][i];
@@ -626,6 +627,7 @@
   if (!(fp= my_fopen(name, O_RDONLY, MYF(0))))
     return 1;					/* Ignore wrong files */
 
+  memset(buff,0,sizeof(buff));
   while (fgets(buff, sizeof(buff) - 1, fp))
   {
     line++;
@@ -742,7 +744,7 @@
     end= remove_end_comment(ptr);
     if ((value= strchr(ptr, '=')))
       end= value;				/* Option without argument */
-    for ( ; my_isspace(&my_charset_utf8_general_ci,end[-1]) ; end--) ;
+    for ( ; my_isspace(&my_charset_utf8_general_ci,end[-1]) || end[-1]== '\n'; end--) ;
     if (!value)
     {
       strncpy(strcpy(option,"--")+2,ptr,strlen(ptr)+1);
@@ -771,7 +773,10 @@
         value++;
         value_end--;
       }
+      
+      memset(option,0,2+(size_t)(end-ptr)+1);
       ptr= strncpy(strcpy(option,"--")+2,ptr,(size_t) (end-ptr));
+      ptr[end-ptr]= '\0';
       ptr+= strlen(ptr);
       *ptr++= '=';
 

